Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 644)
@@ -11,5 +11,8 @@
      .            flxmass_w,
 #endif
-     .            d_u, d_v, d_t, d_qx, d_ps)
+     .            d_u, d_v, d_t, d_qx, d_ps
+cIM Amip2
+     .            , dudyn
+     .            , PVteta)
 
       USE ioipsl
@@ -40,6 +43,6 @@
 #define histins
 c#define histISCCP
-#define histREGDYN
-#define histmthNMC
+c#define histREGDYN
+c#define histmthNMC
 c======================================================================
 c    modif   ( P. Le Van ,  12/10/98 )
@@ -73,4 +76,6 @@
 c d_qx----output-R-tendance physique de "qx" (kg/kg/s)
 c d_ps----output-R-tendance physique de la pression au sol
+cIM
+c PVteta--output-R-vorticite potentielle a des thetas constantes
 c======================================================================
 #include "dimensions.h"
@@ -116,4 +121,12 @@
 c     parameter (ocean = 'couple')
       logical ok_ocean
+      SAVE ok_ocean
+c
+cIM "slab" ocean
+      REAL tslab(klon)    !Temperature du slab-ocean
+      REAL seaice(klon)   !glace de mer (kg/m2) 
+      REAL fluxo(klon)    !flux turbulents ocean-glace de mer 
+      REAL fluxg(klon)    !flux turbulents ocean-atmosphere
+c
 c======================================================================
 c Clef controlant l'activation du cycle diurne:
@@ -188,5 +201,8 @@
       REAL znivsig(klev)
       REAL zsurf(nbsrf)
-
+cIM 
+      INTEGER kinv
+      real pir
+cMI
       REAL u(klon,klev)
       REAL v(klon,klev)
@@ -213,4 +229,18 @@
       REAL d_ps(klon)
       real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
+c
+cIM Amip2 PV a theta constante 
+c
+      INTEGER nbteta
+      PARAMETER(nbteta=3)
+      CHARACTER*3 ctetaSTD(nbteta)
+      DATA ctetaSTD/'350','380','405'/
+      REAL rtetaSTD(nbteta)
+      DATA rtetaSTD/350., 380., 405./
+c
+      REAL PVteta(klon,nbteta)
+      REAL zx_tmp_3dte(iim,jjmp1,nbteta)
+c
+cMI Amip2 PV a theta constante
 
       INTEGER klevp1, klevm1
@@ -238,5 +268,6 @@
       SAVE LWdnTOA, LWdnTOAclr
 c
-c vents meridien et zonal a un niveau de pression
+cIM Amip2
+c variables a une pression donnee
 c
       integer nlevSTD
@@ -246,28 +277,66 @@
      .60000., 50000., 40000., 30000., 25000., 20000.,
      .15000., 10000., 7000., 5000., 3000., 2000., 1000./
-      CHARACTER*5 clevSTD(nlevSTD), aa, bb
+      CHARACTER*4 clevSTD(nlevSTD)
       DATA clevSTD/'1000','925 ','850 ','700 ','600 ',
      .'500 ','400 ','300 ','250 ','200 ','150 ','100 ',
      .'70  ','50  ','30  ','20  ','10  '/
 c
+      CHARACTER*3 bb2
+      CHARACTER*2 bb3
+c
       real tlevSTD(klon,nlevSTD), qlevSTD(klon,nlevSTD)
       real rhlevSTD(klon,nlevSTD), philevSTD(klon,nlevSTD)
       real ulevSTD(klon,nlevSTD), vlevSTD(klon,nlevSTD)
-c
-cIM ENSEMBLES BEG
-c
-      integer nlevENS
-      PARAMETER(nlevENS=4)
-      integer indENS(nlevENS)
-      save indENS
-      real rlevENS(nlevENS)
-      DATA rlevENS/85000., 70000., 50000., 20000./
-      CHARACTER*3 clev(nlevENS)
-      DATA clev/'850','700','500','200'/
- 
-      real tlev(klon,nlevENS), qlev(klon,nlevENS), rhlev(klon,nlevENS)
-      real ulev(klon,nlevENS), vlev(klon,nlevENS), philev(klon,nlevENS)
-      real wlev(klon,nlevENS)
-cIM ENSEMBLES END
+      real wlevSTD(klon,nlevSTD) 
+c
+c nout : niveau de output des variables a une pression donnee
+      INTEGER nout
+      PARAMETER(nout=3) !nout=1 : day; =2 : mth; =3 : NMC
+c
+      REAL tsumSTD(klon,nlevSTD,nout)
+      REAL usumSTD(klon,nlevSTD,nout), vsumSTD(klon,nlevSTD,nout)
+      REAL wsumSTD(klon,nlevSTD,nout), phisumSTD(klon,nlevSTD,nout)
+      REAL qsumSTD(klon,nlevSTD,nout), rhsumSTD(klon,nlevSTD,nout)
+c
+      SAVE tsumSTD, usumSTD, vsumSTD, wsumSTD, phisumSTD, 
+     .     qsumSTD, rhsumSTD
+c
+      logical oknondef(klon,nlevSTD,nout)
+      real tnondef(klon,nlevSTD,nout) 
+      save tnondef
+c
+c les produits uvSTD, vqSTD, .., T2STD sont calcules
+c a partir des valeurs instantannees toutes les 6 h
+c qui sont moyennees sur le mois
+c
+      real uvSTD(klon,nlevSTD)
+      real vqSTD(klon,nlevSTD)
+      real vTSTD(klon,nlevSTD)
+      real wqSTD(klon,nlevSTD)
+c
+      real uvsumSTD(klon,nlevSTD,nout)
+      real vqsumSTD(klon,nlevSTD,nout)
+      real vTsumSTD(klon,nlevSTD,nout)
+      real wqsumSTD(klon,nlevSTD,nout)
+c
+      real vphiSTD(klon,nlevSTD)
+      real wTSTD(klon,nlevSTD)
+      real u2STD(klon,nlevSTD)
+      real v2STD(klon,nlevSTD)
+      real T2STD(klon,nlevSTD)
+c
+      real vphisumSTD(klon,nlevSTD,nout)
+      real wTsumSTD(klon,nlevSTD,nout)
+      real u2sumSTD(klon,nlevSTD,nout)
+      real v2sumSTD(klon,nlevSTD,nout)
+      real T2sumSTD(klon,nlevSTD,nout)
+c
+      SAVE uvsumSTD, vqsumSTD, vTsumSTD, wqsumSTD
+      SAVE vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, T2sumSTD
+cMI Amip2
+c
+#include "radepsi.h"
+#include "radopt.h"
+c
 c
 c prw: precipitable water
@@ -282,5 +351,5 @@
       REAL cldt_s(klon),cldq_s(klon) !nuage total, eau liquide integree
 
-      INTEGER linv, kp1
+      INTEGER kp1
 c flwp, fiwp = Liquid Water Path & Ice Water Path (kg/m2)
 c flwc, fiwc = Liquid Water Content & Ice Water Content (kg/kg)
@@ -292,5 +361,5 @@
       REAL flwc_s(klon,klev), fiwc_s(klon,klev)
 
-c ISCCP simulator v3.4
+cIM ISCCP simulator v3.4
 c dans clesphys.h top_height, overlap
 cv3.4
@@ -322,5 +391,5 @@
       REAL emsfc_lw
       PARAMETER(emsfc_lw=0.99)
-      REAL    ran0                      ! type for random number fuction
+c     REAL    ran0                      ! type for random number fuction
 c
       REAL cldtot(klon,klev)
@@ -351,5 +420,5 @@
       REAL boxptop(klon,ncol) 
 c
-      INTEGER l, ni, nj, kmax, lmax
+      INTEGER l, kmax, lmax
       PARAMETER(kmax=8, lmax=8)
       INTEGER kmaxm1, lmaxm1
@@ -358,6 +427,4 @@
       PARAMETER(iimx7=iim*kmaxm1, jjmx7=jjm*lmaxm1, 
      .jjmp1x7=jjmp1*lmaxm1)
-      REAL fq4d(iim,jjmp1,kmaxm1,lmaxm1)
-      REAL fq3d(iimx7, jjmp1x7)
 c
       INTEGER iw, iwmax
@@ -376,33 +443,42 @@
       SAVE nhistoWt
 
+      INTEGER linv
       INTEGER pct_ocean(klon,nbregdyn)
-      REAL rlonPOS(klon) 
  
 c sorties ISCCP
 
-      logical ok_isccp
-      real ecrit_isccp
+c     logical ok_isccp
+c     real ecrit_isccp
       integer nid_isccp
-      save ok_isccp, ecrit_isccp, nid_isccp        
-
-#ifdef histISCCP
-      data ok_isccp/.true./      
-#else
-      data ok_isccp/.false./
-#endif
+c     save ok_isccp, ecrit_isccp, nid_isccp        
+      save nid_isccp        
+cIM 090704 BEG
+      INTEGER nbapp_isccp,isccppas
+
+#undef histISCCP
+#define histISCCP
+c     data ok_isccp,ecrit_isccp/.true.,0.125/      
+c     data ok_isccp,ecrit_isccp/.true.,1./      
+cIM 190504     data ok_isccp/.true./      
+cIM 190504 #else
+cIM 190504     data ok_isccp/.false./
+cIM 190504 #endif
 
 c sorties statistiques regime dynamique
-      logical ok_regdyn
-      real ecrit_regdyn
+c     logical ok_regdyn
+c     real ecrit_regdyn
       integer nid_regdyn
-      save ok_regdyn, ecrit_regdyn, nid_regdyn
-
-#ifdef histREGDYN
+c     save ok_regdyn, ecrit_regdyn, nid_regdyn
+      save nid_regdyn
+
+#undef histREGDYN
+#define histREGDYN
+cIM 190504 #ifdef histREGDYN
 c     data ok_regdyn,ecrit_regdyn/.true.,0.125/
 c     data ok_regdyn,ecrit_regdyn/.true.,1./
-       data ok_regdyn/.true./
-#else
-      data ok_regdyn/.false./
-#endif 
+cIM 190504    data ok_regdyn/.true./
+cIM 190504 #else
+cIM 190504   data ok_regdyn/.false./
+cIM 190504 #endif 
 
       REAL zx_tau(kmaxm1), zx_pc(lmaxm1), zx_o500(iwmax)
@@ -418,21 +494,83 @@
 c taulev: numero du niveau de tau dans les sorties ISCCP
       CHARACTER *4 taulev(kmaxm1)
-      DATA taulev/'tau1','tau2','tau3','tau4','tau5','tau6','tau7'/
-
-      REAL zx_lonx7(iimx7), zx_latx7(jjmp1x7)
-      INTEGER nhorix7
+c     DATA taulev/'tau1','tau2','tau3','tau4','tau5','tau6','tau7'/
+      DATA taulev/'tau0','tau1','tau2','tau3','tau4','tau5','tau6'/
+      CHARACTER *3 pclev(lmaxm1)
+      DATA pclev/'pc1','pc2','pc3','pc4','pc5','pc6','pc7'/
+c
+c cnameisccp
+      CHARACTER *27 cnameisccp(lmaxm1,kmaxm1)
+      DATA cnameisccp/'pc< 50hPa, tau< 0.3', 
+     .                'pc= 50-180hPa, tau< 0.3',
+     .                'pc= 180-310hPa, tau< 0.3',
+     .                'pc= 310-440hPa, tau< 0.3',
+     .                'pc= 440-560hPa, tau< 0.3',
+     .                'pc= 560-680hPa, tau< 0.3',
+     .                'pc= 680-800hPa, tau< 0.3',
+     .                'pc< 50hPa, tau= 0.3-1.3',
+     .                'pc= 50-180hPa, tau= 0.3-1.3',
+     .                'pc= 180-310hPa, tau= 0.3-1.3',
+     .                'pc= 310-440hPa, tau= 0.3-1.3',
+     .                'pc= 440-560hPa, tau= 0.3-1.3',
+     .                'pc= 560-680hPa, tau= 0.3-1.3',
+     .                'pc= 680-800hPa, tau= 0.3-1.3',
+     .                'pc< 50hPa, tau= 1.3-3.6',
+     .                'pc= 50-180hPa, tau= 1.3-3.6',
+     .                'pc= 180-310hPa, tau= 1.3-3.6',
+     .                'pc= 310-440hPa, tau= 1.3-3.6',
+     .                'pc= 440-560hPa, tau= 1.3-3.6',
+     .                'pc= 560-680hPa, tau= 1.3-3.6',
+     .                'pc= 680-800hPa, tau= 1.3-3.6',
+     .                'pc< 50hPa, tau= 3.6-9.4',
+     .                'pc= 50-180hPa, tau= 3.6-9.4',
+     .                'pc= 180-310hPa, tau= 3.6-9.4',
+     .                'pc= 310-440hPa, tau= 3.6-9.4',
+     .                'pc= 440-560hPa, tau= 3.6-9.4',
+     .                'pc= 560-680hPa, tau= 3.6-9.4',
+     .                'pc= 680-800hPa, tau= 3.6-9.4',
+     .                'pc< 50hPa, tau= 9.4-23',
+     .                'pc= 50-180hPa, tau= 9.4-23',
+     .                'pc= 180-310hPa, tau= 9.4-23',
+     .                'pc= 310-440hPa, tau= 9.4-23',
+     .                'pc= 440-560hPa, tau= 9.4-23',
+     .                'pc= 560-680hPa, tau= 9.4-23',
+     .                'pc= 680-800hPa, tau= 9.4-23',
+     .                'pc< 50hPa, tau= 23-60',
+     .                'pc= 50-180hPa, tau= 23-60',
+     .                'pc= 180-310hPa, tau= 23-60',
+     .                'pc= 310-440hPa, tau= 23-60',
+     .                'pc= 440-560hPa, tau= 23-60',
+     .                'pc= 560-680hPa, tau= 23-60',
+     .                'pc= 680-800hPa, tau= 23-60',
+     .                'pc< 50hPa, tau> 60.',
+     .                'pc= 50-180hPa, tau> 60.',
+     .                'pc= 180-310hPa, tau> 60.',
+     .                'pc= 310-440hPa, tau> 60.',
+     .                'pc= 440-560hPa, tau> 60.',
+     .                'pc= 560-680hPa, tau> 60.',
+     .                'pc= 680-800hPa, tau> 60.'/
+c
+c     REAL zx_lonx7(iimx7), zx_latx7(jjmp1x7)
+c     INTEGER nhorix7
 cIM: region='3d' <==> sorties en global
       CHARACTER*3 region
       PARAMETER(region='3d')
 c
+cIM ISCCP simulator v3.4
+c
       logical ok_hf
-      real ecrit_hf
+cIM200505     integer ecrit_hf
+cIM200505    integer ecrit_hf2mth
+cIM200505    save ecrit_hf2mth
+c
       integer nid_hf, nid_hf3d
-      save ok_hf, ecrit_hf, nid_hf, nid_hf3d
+cIM200505     save ok_hf, ecrit_hf, nid_hf, nid_hf3d
+      save ok_hf, nid_hf, nid_hf3d
 
 c  QUESTION : noms de variables ?
 
 #ifdef histhf
-      data ok_hf,ecrit_hf/.true.,0.25/
+cIM 130904   data ok_hf,ecrit_hf/.true.,0.25/
+      data ok_hf/.true./
 #else
       data ok_hf/.false./
@@ -465,4 +603,7 @@
       REAL rlon(klon)
       SAVE rlon                   ! longitude pour chaque point
+c
+      REAL rlonPOS(klon)
+      SAVE rlonPOS                ! longitudes > 0. pour chaque point
 c
 cc      INTEGER iflag_con
@@ -534,5 +675,6 @@
       SAVE rugoro                 ! longueur de rugosite de l'OESM
 c
-      REAL zulow(klon),zvlow(klon),zustr(klon), zvstr(klon)
+cIM 141004     REAL zulow(klon),zvlow(klon),zustr(klon), zvstr(klon)
+      REAL zulow(klon),zvlow(klon)
 c
       REAL zuthe(klon),zvthe(klon)
@@ -621,8 +763,10 @@
       REAL snow_fall(klon) ! neige
       save snow_fall, rain_fall
-cIM 050204 BEG
+cIM cf FH pour Tiedtke 080604
+      REAL rain_tiedtke(klon),snow_tiedtke(klon)
+c
       REAL total_rain(klon), nday_rain(klon)
-      save total_rain, nday_rain
-cIM 050204 END
+      save nday_rain
+c
       REAL evap(klon), devap(klon) ! evaporation et sa derivee
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
@@ -655,5 +799,5 @@
       REAL pctsrf_new(klon,nbsrf) !pourcentage surfaces issus d'ORCHIDEE
       REAL paire_ter(klon)        !surfaces terre 
-cIM
+c
       SAVE pctsrf                 ! sous-fraction du sol
       REAL albsol(klon)
@@ -699,4 +843,9 @@
       EXTERNAL lnblnk1   !enleve les blancs a la fin d'une variable de type
                          !caracter
+      EXTERNAL ini_undefSTD  !initialise a 0 une variable a 1 niveau de pression
+      EXTERNAL undefSTD      !somme les valeurs definies d'1 var a 1 niveau de pression
+c     EXTERNAL moy_undefSTD  !moyenne d'1 var a 1 niveau de pression
+c     EXTERNAL moyglo_aire   !moyenne globale d'1 var ponderee par l'aire de la maille (moyglo_pondaire)
+c                            !par la masse/airetot (moyglo_pondaima) et la vraie masse (moyglo_pondmass)
 c
 c Variables locales
@@ -704,4 +853,7 @@
       real clwcon(klon,klev),rnebcon(klon,klev)
       real clwcon0(klon,klev),rnebcon0(klon,klev)
+cIM cf. AM 081204 BEG
+      real clwcon0th(klon,klev),rnebcon0th(klon,klev)
+cIM cf. AM 081204 END
       save rnebcon, clwcon
 
@@ -770,12 +922,29 @@
       REAL zx_t, zx_qs, zdelta, zcor, zfra, zlvdcp, zlsdcp
       real zqsat(klon,klev)
-      INTEGER i, k, iq, ig, j, iiq, nsrf, ll
+      INTEGER i, k, iq, ig, j, nsrf, ll
       REAL t_coup
       PARAMETER (t_coup=234.0)
 c
       REAL zphi(klon,klev)
-      REAL zx_tmp_x(iim), zx_tmp_yjjmp1
       REAL zx_relief(iim,jjmp1)
       REAL zx_aire(iim,jjmp1)
+c
+cIM cf. AM Variables locales pour la CLA (hbtm2)
+c
+      REAL pblh(klon, nbsrf)           ! Hauteur de couche limite
+      REAL plcl(klon, nbsrf)           ! Niveau de condensation de la CLA
+      REAL capCL(klon, nbsrf)          ! CAPE de couche limite
+      REAL oliqCL(klon, nbsrf)          ! eau_liqu integree de couche limite
+      REAL cteiCL(klon, nbsrf)          ! cloud top instab. crit. couche limite
+      REAL pblt(klon, nbsrf)          ! T a la Hauteur de couche limite
+      REAL therm(klon, nbsrf)
+      REAL trmb1(klon, nbsrf)          ! deep_cape
+      REAL trmb2(klon, nbsrf)          ! inhibition 
+      REAL trmb3(klon, nbsrf)          ! Point Omega
+c Grdeurs de sorties
+      REAL s_pblh(klon), s_lcl(klon), s_capCL(klon)
+      REAL s_oliqCL(klon), s_cteiCL(klon), s_pblt(klon)
+      REAL s_therm(klon), s_trmb1(klon), s_trmb2(klon)
+      REAL s_trmb3(klon)
 cKE43
 c Variables locales pour la convection de K. Emanuel (sb):
@@ -796,5 +965,5 @@
       INTEGER iflagctrl(klon)          ! flag fonctionnement de convect
 c -- convect43:
-      INTEGER ntra              ! nb traceurs 
+      INTEGER ntra              ! nb traceurs pour convect4.3
       REAL pori_con(klon)    ! pressure at the origin level of lifted parcel
       REAL plcl_con(klon),dtma_con(klon),dtlcl_con(klon)
@@ -820,5 +989,14 @@
       REAL d_u_ajs(klon,klev), d_v_ajs(klon,klev)
       REAL d_t_eva(klon,klev),d_q_eva(klon,klev)
+      REAL d_t_oli(klon,klev) !tendances dues a oro et lif 
       REAL rneb(klon,klev)
+c
+*********************************************************
+*     declarations
+      real zqasc(klon,klev)
+      save zqasc
+      
+*********************************************************
+cIM 081204 END
 c
       REAL pmfu(klon,klev), pmfd(klon,klev)
@@ -863,19 +1041,37 @@
 
       logical ptconv(klon,klev)
-
+cIM cf. AM 081204 BEG
+      logical ptconvth(klon,klev)
+cIM cf. AM 081204 END
 c
 c Variables liees a l'ecriture de la bande histoire physique
 c
-      INTEGER ecrit_mth
-      SAVE ecrit_mth   ! frequence d'ecriture (fichier mensuel)
-c
-      INTEGER ecrit_day
-      SAVE ecrit_day   ! frequence d'ecriture (fichier journalier)
-c
-      INTEGER ecrit_ins
-      SAVE ecrit_ins   ! frequence d'ecriture (fichier instantane)
-c
-      INTEGER ecrit_reg
-      SAVE ecrit_reg   ! frequence d'ecriture
+c======================================================================
+cIM200505     INTEGER ecrit_mth
+cIM200505     SAVE ecrit_mth   ! frequence d'ecriture (fichier mensuel)
+c
+cIM cf. AM 081204 BEG
+c   declarations pour sortir sur une sous-region
+      integer imin_ins,imax_ins,jmin_ins,jmax_ins
+      save imin_ins,imax_ins,jmin_ins,jmax_ins
+c      real lonmin_ins,lonmax_ins,latmin_ins
+c     s  ,latmax_ins
+c     data lonmin_ins,lonmax_ins,latmin_ins
+c    s  ,latmax_ins/
+c valeurs initiales     s   -5.,20.,41.,55./   
+c    s   100.,130.,-20.,20./
+c    s   -180.,180.,-90.,90./
+c======================================================================
+cIM cf. AM 081204 END
+
+c
+cIM200505     INTEGER ecrit_day
+cIM200505     SAVE ecrit_day   ! frequence d'ecriture (fichier journalier)
+c
+cIM200505     INTEGER ecrit_ins
+cIM200505     SAVE ecrit_ins   ! frequence d'ecriture (fichier instantane)
+c
+cIM200505     INTEGER ecrit_reg
+cIM200505     SAVE ecrit_reg   ! frequence d'ecriture
 c
       integer itau_w   ! pas de temps ecriture = itap + itau_phy
@@ -898,14 +1094,53 @@
 c
       INTEGER ndex2d(iim*jjmp1),ndex3d(iim*jjmp1*klev)
+c
+cIM AMIP2 BEG
+      REAL moyglo, mountor
+cIM 141004 BEG
+      REAL zustrdr(klon), zvstrdr(klon)
+      REAL zustrli(klon), zvstrli(klon)
+      REAL zustrph(klon), zvstrph(klon)
+      REAL aam, torsfc
+cIM 141004 END
+cIM 190504 BEG
+      INTEGER ij, imp1jmp1
+      PARAMETER(imp1jmp1=(iim+1)*jjmp1)
+      REAL zx_tmp(imp1jmp1), airedyn(iim+1,jjmp1)
+      REAL padyn(iim+1,jjmp1,klev+1)
+      REAL dudyn(iim+1,jjmp1,klev)
+      REAL rlatdyn(iim+1,jjmp1)
+cIM 190504 END
+      LOGICAL ok_msk
+      REAL msk(klon)
+cIM 
+      REAL airetot, pi
+      REAL zm_wo(jjmp1, klev)
+cIM AMIP2 END
+c
       REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
       REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
+      REAL*8 zx_tmp2_fi3d(klon,klev) ! variable temporaire pour champs 3D 
       REAL zx_tmp_2d(iim,jjmp1), zx_tmp_3d(iim,jjmp1,klev)
       REAL zx_lon(iim,jjmp1), zx_lat(iim,jjmp1)
 c
-      INTEGER nid_day, nid_mth, nid_ins, nid_nmc
-      SAVE nid_day, nid_mth, nid_ins, nid_nmc
-c
-      INTEGER nhori, nvert
+      INTEGER nid_day, nid_mth, nid_ins, nid_nmc, nid_day_seri
+      SAVE nid_day, nid_mth, nid_ins, nid_nmc, nid_day_seri
+c
+cIM 280405 BEG
+      INTEGER nid_bilKPins, nid_bilKPave
+      SAVE nid_bilKPins, nid_bilKPave
+c
+      REAL ve_lay(klon,klev) ! transport meri. de l'energie a chaque niveau vert.
+      REAL vq_lay(klon,klev) ! transport meri. de l'eau a chaque niveau vert.
+      REAL ue_lay(klon,klev) ! transport zonal de l'energie a chaque niveau vert.
+      REAL uq_lay(klon,klev) ! transport zonal de l'eau a chaque niveau vert.
+c
+cIM 280405 END
+c
+      INTEGER nhori, nvert, nvert1
+c     REAL zstok
       REAL zsto, zout, zsto1, zsto2
+c     REAL zstoave, zstoin 
+      REAL zstophy, zstorad, zstohf, zstoday, zstomth
       real zjulian
       save zjulian
@@ -954,4 +1189,5 @@
       REAL zu10m(klon), zv10m(klon)           !vents a 10m moyennes s/1 maille
       CHARACTER*40 t2mincels, t2maxcels       !t2m min., t2m max
+      CHARACTER*40 tinst, tave, typeval
 cjq   Aerosol effects (Johannes Quaas, 27/11/2003)
       REAL sulfate(klon, klev) ! SO4 aerosol concentration [ug/m3]
@@ -1041,34 +1277,8 @@
       IF (debut) THEN
          CALL suphec ! initialiser constantes et parametres phys.
-c
-cIM 050204 BEG
-         DO i=1, klon
-          nday_rain(i)=0.
-         ENDDO
-cIM 050204 END
-c
+      ENDIF
+
+
 c======================================================================
-cIM BEG
-        DO k=1, nlevENS
-          DO l=1, nlevSTD
-c
-            bb=clevSTD(l)
-c
-            IF(l.GE.2) THEN
-             aa=clevSTD(l)
-             bb=aa(1:lnblnk1(aa))
-            ENDIF
-c
-            IF(bb.EQ.clev(k)) THEN
-c             print*,'k=',k,'l=',l,'clev=',clev(k)
-              indENS(k)=l
-c             print*,'k=',k,'l=',l,'clev=',clev(k),'indENS=',indENS(k)
-            ENDIF 
-c
-          ENDDO 
-        ENDDO 
-c
-      ENDIF !debut
-cIM END
       xjour = rjourvrai
 c
@@ -1098,5 +1308,8 @@
          itaprad = 0
          CALL phyetat0 ("startphy.nc",dtime,co2_ppm_etat0,solaire_etat0,
-     .       rlat,rlon,pctsrf, ftsol,ftsoil,deltat,fqsurf,qsol,fsnow,
+     .       rlat,rlon,pctsrf, ftsol,ftsoil,
+cIM "slab" ocean
+     .       tslab,seaice,
+     .       fqsurf,qsol,fsnow,
      .       falbe, falblw, fevap, rain_fall,snow_fall,solsw, sollwdown,
      .       dlw,radsol,frugs,agesno,clesphy0,
@@ -1116,4 +1329,11 @@
          ENDIF
 
+cIM cf. AM 081204 BEG
+         PRINT*,'cycle_diurne3 =',cycle_diurne
+cIM cf. AM 081204 END
+c
+         IF(ocean.NE.'force ') THEN
+          ok_ocean=.TRUE.
+         ENDIF
 c
          CALL printflag( tabcntr0,radpas,ok_ocean,ok_oasis ,ok_journe,
@@ -1191,28 +1411,52 @@
      .                   lmt_pas
 c
-         ecrit_mth = NINT(86400./dtime *ecritphy)  ! tous les ecritphy jours
-         IF (ok_mensuel) THEN
-         WRITE(lunout,*)'La frequence de sortie mensuelle est de ', 
-     .                   ecrit_mth
-         ENDIF
-         ecrit_day = NINT(86400./dtime *1.0)  ! tous les jours
-         IF (ok_journe) THEN
-         WRITE(lunout,*)'La frequence de sortie journaliere est de ',
-     .                   ecrit_day
-         ENDIF
+cIM200505        ecrit_mth = NINT(86400./dtime *ecritphy)  ! tous les ecritphy jours
+c        IF (ok_mensuel) THEN
+c        WRITE(lunout,*)'La frequence de sortie mensuelle est de ', 
+c    .                   ecrit_mth
+c        ENDIF
+c        ecrit_day = NINT(86400./dtime *1.0)  ! tous les jours
+c        IF (ok_journe) THEN
+c        WRITE(lunout,*)'La frequence de sortie journaliere est de ',
+c    .                   ecrit_day
+c        ENDIF
+cIM 130904 BEG
+cIM 080205      ecrit_hf = 86400./dtime *0.25  ! toutes les 6h
+cIM 170305      
+c        ecrit_hf = 86400./dtime/12.  ! toutes les 2h
+cIM 230305      
+cIM200505        ecrit_hf = 86400./dtime *0.25  ! toutes les 6h
+c
+cIM200505        ecrit_hf2mth = ecrit_day/ecrit_hf*30
+c
+cIM200505        IF (ok_journe) THEN
+cIM200505        WRITE(lunout,*)'La frequence de sortie hf est de ',
+cIM200505    .                   ecrit_hf
+cIM200505        ENDIF
+cIM 130904 END
 ccc         ecrit_ins = NINT(86400./dtime *0.5)  ! 2 fois par jour
 ccc         ecrit_ins = NINT(86400./dtime *0.25)  ! 4 fois par jour
-         ecrit_ins = NINT(86400./dtime/48.)  ! a chaque pas de temps ==> PB. dans time_counter pour 1mois
-         ecrit_ins = NINT(86400./dtime/12.)  ! toutes les deux heures
-         IF (ok_instan) THEN
-         WRITE(lunout,*)'La frequence de sortie instant. est de ', 
-     .                   ecrit_ins
-         ENDIF
-         ecrit_reg = NINT(86400./dtime *0.25)  ! 4 fois par jour
-         IF (ok_region) THEN
-         WRITE(lunout,*)'La frequence de sortie region est de ', 
-     .                   ecrit_reg
-         ENDIF
-
+c        ecrit_ins = NINT(86400./dtime/48.)  ! a chaque pas de temps ==> PB. dans time_counter pour 1mois
+c        ecrit_ins = NINT(86400./dtime/12.)  ! toutes les deux heures
+cIM200505        ecrit_ins = NINT(86400./dtime/8.)  ! toutes les trois heures
+cIM200505        IF (ok_instan) THEN
+cIM200505        WRITE(lunout,*)'La frequence de sortie instant. est de ', 
+cIM200505    .                   ecrit_ins
+cIM200505        ENDIF
+cIM200505        ecrit_reg = NINT(86400./dtime *0.25)  ! 4 fois par jour
+cIM200505        IF (ok_region) THEN
+cIM200505        WRITE(lunout,*)'La frequence de sortie region est de ', 
+cIM200505    .                   ecrit_reg
+cIM200505        ENDIF
+c
+cIM 230505 BEG
+         ecrit_ins = NINT(ecrit_ins/dtime)
+         ecrit_hf = NINT(ecrit_hf/dtime)
+c        ecrit_hf2mth = 4*30
+         ecrit_day = NINT(ecrit_day/dtime)
+         ecrit_mth = NINT(ecrit_mth/dtime)
+         ecrit_tra = NINT(ecrit_tra/dtime)
+         ecrit_reg = NINT(ecrit_reg/dtime)
+cIM 230505 END
 c
 c Initialiser le couplage si necessaire
@@ -1229,10 +1473,12 @@
       endif        
 c
-c
-cIM
       capemaxcels = 't_max(X)'
       t2mincels = 't_min(X)'
       t2maxcels = 't_max(X)'
-
+      tinst = 'inst(X)'
+      tave = 'ave(X)'
+cIM cf. AM 081204 BEG
+      write(lunout,*)'AVANT HIST IFLAG_CON=',iflag_con
+cIM cf. AM 081204 END
 c
 c=============================================================
@@ -1248,4 +1494,8 @@
 #ifdef histday
 #include "ini_histday.h"
+cIM rajout diagnostiques bilan KP pour analyse MJO par Jun-Ichi Yano
+c#include "ini_bilKP_ins.h"
+c#include "ini_bilKP_ave.h"
+#include "ini_histday_seri.h"
 #endif
 
@@ -1273,4 +1523,11 @@
 #include "ini_histISCCP.h"
 #endif
+
+c#undef histmthNMC
+c#define histmthNMC
+#ifdef histmthNMC
+#include "ini_histmthNMC.h"
+#endif
+
 #endif
 
@@ -1504,11 +1761,5 @@
         rmu0 = -999.999
       ENDIF
-cIM BEG
-      DO i=1, klon
-       sunlit(i)=1 
-       IF(rmu0(i).EQ.0.) sunlit(i)=0
-       nbsunlit(1,i)=FLOAT(sunlit(i))
-      ENDDO
-cIM END
+c
 C     Calcul de l'abedo moyen par maille
       albsol(:)=0.
@@ -1545,8 +1796,9 @@
      $            soil_model,cdmmax, cdhmax,
      $            ksta, ksta_ter, ok_kzmin, ftsoil, qsol, 
-     $            paprs,pplay,radsol, fsnow,fqsurf,fevap,falbe,falblw,
+cIM BAD    $            paprs,pplay,radsol, fsnow,fqsurf,fevap,falbe,falblw,
+     $            paprs,pplay, fsnow,fqsurf,fevap,falbe,falblw,
      $            fluxlat,
-cIM cf. JLD  e            rain_fall, snow_fall, solsw, sollw, sollwdown, fder,
-     e            rain_fall, snow_fall, fsolsw, fsollw, sollwdown, fder,
+     e            rain_fall, snow_fall,
+     e            fsolsw, fsollw, sollwdown, fder,
      e            rlon, rlat, cuphy, cvphy, frugs,
      e            debut, lafin, agesno,rugoro ,
@@ -1556,5 +1808,11 @@
      s            dsens, devap,
      s            ycoefh,yu1,yv1, t2m, q2m, u10m, v10m,
-     s            fqcalving, ffonte, run_off_lic_0) 
+cIM cf. AM 081204 BEG
+     s            pblh,capCL,oliqCL,cteiCL,pblT,
+     s            therm,trmb1,trmb2,trmb3,plcl,
+cIM cf. AM 081204 END
+     s            fqcalving, ffonte, run_off_lic_0,
+cIM "slab" ocean
+     s            fluxo, fluxg, tslab, seaice) 
 c
 CXXX PB
@@ -1623,4 +1881,16 @@
          zxffonte(i) = 0.0
          zxfqcalving(i) = 0.0
+cIM cf. AM 081204 BEG
+c
+         s_pblh(i) = 0.0 
+         s_lcl(i) = 0.0 
+         s_capCL(i) = 0.0
+         s_oliqCL(i) = 0.0
+         s_cteiCL(i) = 0.0
+         s_pblT(i) = 0.0
+         s_therm(i) = 0.0
+         s_trmb1(i) = 0.0
+         s_trmb2(i) = 0.0
+         s_trmb3(i) = 0.0
 c
          IF ( abs( pctsrf(i, is_ter) + pctsrf(i, is_lic) + 
@@ -1649,4 +1919,15 @@
             zxfqcalving(i) = zxfqcalving(i) + 
      .                      fqcalving(i,nsrf)*pctsrf(i,nsrf)
+cIM cf. AM 081204 BEG
+            s_pblh(i) = s_pblh(i) + pblh(i,nsrf)*pctsrf(i,nsrf)
+            s_lcl(i) = s_lcl(i) + plcl(i,nsrf)*pctsrf(i,nsrf)
+            s_capCL(i) = s_capCL(i) + capCL(i,nsrf) *pctsrf(i,nsrf)
+            s_oliqCL(i) = s_oliqCL(i) + oliqCL(i,nsrf) *pctsrf(i,nsrf)
+            s_cteiCL(i) = s_cteiCL(i) + cteiCL(i,nsrf) *pctsrf(i,nsrf)
+            s_pblT(i) = s_pblT(i) + pblT(i,nsrf) *pctsrf(i,nsrf)
+            s_therm(i) = s_therm(i) + therm(i,nsrf) *pctsrf(i,nsrf)
+            s_trmb1(i) = s_trmb1(i) + trmb1(i,nsrf) *pctsrf(i,nsrf)
+            s_trmb2(i) = s_trmb2(i) + trmb2(i,nsrf) *pctsrf(i,nsrf)
+            s_trmb3(i) = s_trmb3(i) + trmb3(i,nsrf) *pctsrf(i,nsrf)
 c        ENDIF 
         ENDDO
@@ -1668,4 +1949,15 @@
           IF (pctsrf(i,nsrf) .LT. epsfra) 
      .    fqcalving(i,nsrf) = zxfqcalving(i)
+cIM cf. AM 081204 BEG
+          IF (pctsrf(i,nsrf) .LT. epsfra) pblh(i,nsrf)=s_pblh(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) plcl(i,nsrf)=s_lcl(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) capCL(i,nsrf)=s_capCL(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) oliqCL(i,nsrf)=s_oliqCL(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) cteiCL(i,nsrf)=s_cteiCL(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) pblT(i,nsrf)=s_pblT(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) therm(i,nsrf)=s_therm(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) trmb1(i,nsrf)=s_trmb1(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) trmb2(i,nsrf)=s_trmb2(i)
+          IF (pctsrf(i,nsrf) .LT. epsfra) trmb3(i,nsrf)=s_trmb3(i)
         ENDDO
       ENDDO
@@ -2040,9 +2332,33 @@
 c 1. NUAGES CONVECTIFS
 c
-      IF (iflag_cldcon.eq.-1) THEN ! seulement pour Tiedtke
+cIM cf FH
+c     IF (iflag_cldcon.eq.-1) THEN ! seulement pour Tiedtke
+       IF (iflag_cldcon.le.-1) THEN ! seulement pour Tiedtke
+       snow_tiedtke=0.
+c     print*,'avant calcul de la pseudo precip '
+c     print*,'iflag_cldcon',iflag_cldcon
+       if (iflag_cldcon.eq.-1) then
+          rain_tiedtke=rain_con
+       else
+c       print*,'calcul de la pseudo precip '
+          rain_tiedtke=0.
+c         print*,'calcul de la pseudo precip 0'
+          do k=1,klev
+          do i=1,klon
+             if (d_q_con(i,k).lt.0.) then
+                rain_tiedtke(i)=rain_tiedtke(i)-d_q_con(i,k)/pdtphys
+     s         *(paprs(i,k)-paprs(i,k+1))/rg
+             endif
+          enddo
+          enddo
+       endif
+c
+c     call dump2d(iim,jjm,rain_tiedtke(2:klon-1),'PSEUDO PRECIP ')
+c
 
 c Nuages diagnostiques pour Tiedtke
       CALL diagcld1(paprs,pplay,
-     .             rain_con,snow_con,ibas_con,itop_con,
+cIM cf FH  .             rain_con,snow_con,ibas_con,itop_con,
+     .             rain_tiedtke,snow_tiedtke,ibas_con,itop_con,
      .             diafra,dialiq)
       DO k = 1, klev
